/***********************************************************************/
/* Nom: logController.c                                                */
/* Version: 0.4                                                        */
/* Auteur: Trankill - tranquille_che@yahoo.com                         */
/* Utilite: Controle de la taille des fichiers de log                  */
/***********************************************************************/
 
#include "logController.h"

type_Liste_Fichiers *Fichier = NULL ;

/* Programme Principal */
int main( int   argc, char *argv[] )
{
  int log ;
  int NewStderr ;
  type_Liste_Fichiers * Parcours ; 
  char *Arc[3] ;

  /* Utilisation d'un fichier de log */
  if (LOG == "OK")
  {
    /* Ouverture du fichier log en ecriture */
    if ((log = open(FICHIER_LOG,O_CREAT | O_WRONLY | O_APPEND,420)) == ERREUR )  
    {
      Date(1) ;
      perror("Impossible d'accder au fichier de log") ;
      exit(ERREUR) ;
    } 
   
    /* Sauvegarde du canal d'erreur (2) */
    NewStderr = dup(2) ;

    /* Remplacement du canal d'erreur par le fichier de log */
    if (dup2(log,2) == ERREUR)
      {
	Date(1) ;
	perror("Impossible de remplacer le canal sdterr") ;
	exit(ERREUR) ;
      }
  }
  
  /* Lecture de toutes les donnes du fichier de configuration */
  LireFichierConfig(Arc) ;
 
  Parcours = Fichier ;
  
  /* Verification et reduction, si ya besoin, des fichiers */
  while(Parcours != NULL)
    {
      if ((VerifTaille(Parcours->Nom,Parcours->TailleMax)) != 0) 
	{
	  ReducTaille(Parcours->Nom, Parcours->TailleMin, Arc) ;
	}
      Parcours = Parcours->Suivant ;
    }
  
  if (PRINT == "OK")
    fprintf(stdout,"logController OK !\n") ;

  /* Remise en place propre du canal d'erreur */
  dup2(2,NewStderr) ;

  /* Tout c'est bien passe */
  return OK ;

}

/***********************************************************************************/
/* FONCTIONS                                                                       */
/***********************************************************************************/

void LireFichierConfig(char *Arc[])
{
  FILE *Conf ;  		   
  char *buffer;  
  int Taille ;
  type_Liste_Fichiers * Temp ;
  char *Buffy_F[30] ;
  char *Buffy_M[30] ;
  char *Buffy_R[30] ;
  int i = 0 ;

  Temp = calloc(1,sizeof(type_Liste_Fichiers)) ;
    
  /* Ouverture du fichier logController.conf en lecture */
  if ((Conf = fopen(FICHIER_CONFIG,"r")) == NULL) 
  {
    Date(1) ;
    perror("\nPas de fichier de configuration !!(logController.conf)") ;
    exit (ERREUR) ;
  }
  
  /* Allocation de la bonne taille memoire pour le buffer du log */
  Taille = VerifTaille(FICHIER_CONFIG, 0) ;
  buffer = calloc(1,Taille) ;

  /* Ecriture du fichier de config dans un buffer */
  if ((fread(buffer,Taille,1,Conf)) != 1)
  {
    Date(1) ;
    perror("\nErreur de lecture du fichier de configuration !!(logController.conf)") ;
    exit (ERREUR) ;
  }  

  /* Recherche du nom dans le buffer du fichier de config */ 
  if (RechercheMotCle(buffer,MOT_CLE_FICHIER,Buffy_F) == ERREUR)
  {
      Date(1) ;
      fprintf(stderr,"\nAucun fichier de log  vrifier dans logController.conf") ;
      exit(ERREUR) ;
  }
  
  /* Recherche de la taille de retour dans le buffer du fichier de config */ 
  if (RechercheMotCle(buffer,MOT_CLE_RETOUR,Buffy_R) == ERREUR)
  {
      Date(1) ;
      fprintf(stderr,"\nAucune taille de retour spcifie dans logController.conf") ;
      exit(ERREUR) ;
  }

  /* Recherche de la taille max dans le buffer du fichier de config */ 
  if (RechercheMotCle(buffer,MOT_CLE_TAILLE_MAX,Buffy_M) == ERREUR)
  {
      Date(1) ;
      fprintf(stderr,"\nAucune taille max spcifie dans logController.conf") ;
      exit(ERREUR) ;
  }

  /* Ajout dans la liste des fichier  traiter des noms trouvs dans le conf */
  while(strcmp(Buffy_F[i],"FIN") != 0)
  {
    strncpy(Temp->Nom, Buffy_F[i], strlen(Buffy_F[i])) ;
    Temp->TailleMin = atoi(Buffy_R[i]) ;
    Temp->TailleMax = atoi(Buffy_M[i]) ;
    Ajouter(Temp) ;
    memset(Temp, 0, sizeof(type_Liste_Fichiers)) ;
    i++ ;
  }
  
  if (RechercheMotCle(buffer,MOT_CLE_ARCHIVAGE,Arc) == ERREUR)
  {
      Date(1) ;
      fprintf(stderr,"\nImpossible de trouver le paramtre ARC dans logController.conf") ;
      exit(ERREUR) ;
  }

  if(strncmp(Arc[0],"YES", strlen(Arc[0])) == 0)
    {
      if (RechercheMotCle(buffer,MOT_CLE_UTIL_ARCHIVAGE,&Arc[1]) == ERREUR)
	{
	  Date(1) ;
	  fprintf(stderr,"\nImpossible de trouver le paramtre ARC dans logController.conf") ;
	  exit(ERREUR) ;
	}
      
      if (RechercheMotCle(buffer,MOT_CLE_PATH_ARCHIVAGE,&Arc[2]) == ERREUR)
	{
	  Date(1) ;
	  fprintf(stderr,"\nImpossible de trouver le paramtre ARC dans logController.conf") ;
	  exit(ERREUR) ;
	} 
      
    } 

  fclose(Conf) ; /* Fermeture du fichier de configuration */

}

/*****************************************************************************/


/* Remplir date dans le fichier de log */
struct tm* Date(int A)
{
 time_t ConnectDate;
 struct tm *TMDate;

 /* Prise de la date systeme en secondes */
 time(&ConnectDate);
 
 /* Conversion de la date en version plus jolie */
 TMDate=gmtime(&ConnectDate);
 
 /* Sous Linux, le moi de Janvier est le mois 0 */
 TMDate->tm_mon++;
 
 /* Modelisation de la date sur 4 chiffres */
 TMDate->tm_year =  TMDate->tm_year + 1900;
        
        /* Gestion du changement de siecle */
        if (TMDate->tm_year<1999)
        TMDate->tm_year = TMDate->tm_year + 100;
  
 if(A)
   {
     /* Ecriture de la date dans le fichier de log */
     fprintf(stderr,"\n%d %s %d %s %d %s %d %s %d %s %d",
	     TMDate->tm_mday,"/",TMDate->tm_mon,"/",
	     TMDate->tm_year," ",TMDate->tm_hour+2,":",
	     TMDate->tm_min,":",TMDate->tm_sec);
   }
 return TMDate ;
}

/*****************************************************************************/

int RechercheMotCle(char *buffer, char *motCle, char *tabo[])
{
  /* Declaration des variables */
   int		taille_buf,
        	i,
                j = 0 ;
  
   int update = 0 ;  
   char data[100] ;
   int retour = ERREUR ;   

   /* Analyse du buffer caractere par caractere */
   taille_buf = strlen(buffer) ;     
   for(i = 0; i < taille_buf; i ++)
   {
     
      /* Gestion des commentaires avec # */
      if(buffer[i] == '#')
      {
      	while(buffer[i] != '\n' && i < taille_buf)
           i ++ ;
      }

      /* Recherche du mot cle */
      if(strncmp(&buffer[i], motCle, strlen(motCle)) == 0)
      {  
         i = i + strlen(motCle) ;
         while(buffer[i] != '"' && i < taille_buf)
         {  
           i ++ ;
         }
         i ++ ;

   	/* Copie du champ associe au mot cle */
        while(buffer[i] != '"' && i < (taille_buf-1))
        {  
           data[j] = buffer[i] ;
           j ++ ;
           i ++ ;
        }
        data[j] = 0 ;

      tabo[update] = calloc(1,strlen(data)) ;
	
      strncpy(tabo[update], data, strlen(data)) ;
      
      memset(data, 0, sizeof(data)) ;

      update++ ;
      j = 0 ;
      
      retour = OK ;
      }
   } 
   tabo[update] = calloc(1,strlen("FIN")) ;
   strncpy(tabo[update], "FIN", strlen("FIN")) ;
   
   return retour ;
}

/*****************************************************************************/


int VerifTaille(char* Fichier, int TailleMax)
{
  int FileSize ;
  FILE * Verif ;  

  /* Ouverture du fichier  vrifier en lecture */
  if ((Verif = fopen(Fichier,"r")) == NULL) 
  {
    Date(1) ;
    fprintf(stderr,"\nImpossible de trouver le fichier: %s", Fichier) ;
    exit (ERREUR) ;
  }
 
  if ((FileSize = lseek(fileno(Verif), 0, SEEK_END)) == ERREUR) 
  {
    Date(1) ;
    perror("\nImpossible de calculer la taille du fichier") ;
    exit (ERREUR) ;

  }

  fclose(Verif) ;
  
  /* Test si le programme doit effectuer la reducion ou pas */
  if (FileSize > TailleMax)
    return FileSize ;
 
  return 0 ;

}

/*****************************************************************************/


void ReducTaille(char * Fichier, int NouvelleTaille, char *Arc[])
{
  FILE * AReduire ; 
  char *Buffer ;

  if (PRINT == "OK")
    fprintf(stdout,"\nReduction de %s  %d octets\n",Fichier, NouvelleTaille) ; 

  /* Ouverture du fichier  rduire en lecture */
  if ((AReduire = fopen(Fichier,"r")) == NULL) 
  {
    Date(1) ;
    fprintf(stderr,"\nImpossible de trouver le fichier: %s", Fichier) ;
    exit (ERREUR) ;
  }

  /* Si on doit compresser la partie  virer du log */
  if (strncmp(Arc[0],"YES", strlen(Arc[0])) == 0)
    {
      FILE *  Save ;
      char *Buffer2 ;
      int Taille ;
      char Path[80] ;
      char *temp ;
      struct tm *DateSave ;
      char *temp2 ;
      char *Arguments[6] ;

      Taille = (VerifTaille(Fichier, 0) - NouvelleTaille) ;
      Buffer2 = calloc(1,Taille) ;
      
      memset(Path, 0, sizeof(Path)) ;
      
      temp2 = calloc(1,70) ;

      /* copie du path trouve dans le conf dans la variable */
      strncpy(Path, Arc[2], strlen(Arc[2])) ;
      
      /* Recherche du nom du fichier  reduire */
      temp = strrchr(Fichier, '/') ;

      /* Ecriture du nom du fichier a reduire a la suite du path */
      strcat(Path,temp) ;

      /* Acquisition de la date + heure systeme */
      DateSave = Date(0) ;
      
      sprintf(temp2,"-%d%s%d%s%d%s%d%s%d%s%d",
	     DateSave->tm_mday,"-",DateSave->tm_mon,"-",
	     DateSave->tm_year,"-",DateSave->tm_hour+2,":",
	     DateSave->tm_min,":",DateSave->tm_sec);

      /* Rajout de la date au nom de fichier */
      strcat(Path,temp2) ;

      /* Sauvegarde la zone dans un buffer */
      if ((read(fileno(AReduire), Buffer2, Taille)) != Taille) 
	{
	  Date(1) ;
	  perror("\nErreur de lecture dans le fichier.") ;
	  exit (ERREUR) ;
	} 

      /* Creation du fichier de sauvegarde du log */
      if ((Save = fopen(Path, "w")) == NULL)  
	{
	  Date(1) ;
	  fprintf(stderr,"\nImpossible d'utiliser le fichier: %s", Path) ;
	  exit (ERREUR) ;
	}
      
      /* Ecriture dans le fichier de sauvegarde */
      if ((write(fileno(Save), Buffer2, Taille)) != Taille ) 
	{
	  Date(1) ;
	  perror("\nErreur d'ecriture dans le nouveau fichier.") ;
	  exit (ERREUR) ;
	}
      fclose(Save) ;   
      
      if (strncmp(Arc[1],"gz", strlen(Arc[1])) == 0) 
	{ 
	  int PID ;

	  Arguments[0] = calloc(1,strlen(PATH_GZIP)) ;
	  strncpy(Arguments[0], PATH_GZIP, strlen(PATH_GZIP)) ;
	  
	  Arguments[1] = calloc(1,strlen(Path)) ;
	  strncpy(Arguments[1], Path, strlen(Path)) ;
	  
	  Arguments[2] = calloc(1,strlen(Path)) ;
	  Arguments[2] = NULL ;

	  PID = fork() ;

	  switch(PID)
	    {
	    case 0 :
	      
	      if ((execv(PATH_GZIP, Arguments)) == ERREUR ) 
		{
		  Date(1) ;
		  fprintf(stderr,"\nImpossible de compresser en gzip (%s)",PATH_GZIP) ;
		  exit (ERREUR) ;
		}
	      break ;
	    
	    default:
	      break ;
	    }
	}
      else
	{
	  if (strncmp(Arc[1],"bz2", strlen(Arc[1])) == 0)
	    {
	      Arguments[0] = calloc(1,strlen(PATH_BZIP2)) ;
	      strncpy(Arguments[0], PATH_BZIP2, strlen(PATH_BZIP2)) ;
	      
	      Arguments[1] = calloc(1,strlen(Path)) ;
	      strncpy(Arguments[1], Path, strlen(Path)) ;
	      
	      Arguments[2] = calloc(1,strlen(Path)) ;
	      Arguments[2] = NULL ;
	      
	      if ((execv(PATH_BZIP2, Arguments)) == ERREUR ) 
		{
		  Date(1) ;
		  fprintf(stderr,"\nImpossible de compresser en bzip2 (%s)",PATH_BZIP2) ;
		  exit (ERREUR) ;
		}
	    }
	  else
	    {
	      Date(1) ;
	      fprintf(stderr,"\nErreur dans le format de compression (gz ou bz2).") ;
	      exit (ERREUR) ;
	    }
	}
    }

  /* Placement de l'offset devant la zone  sauvegarder */
      
  if ((fseek(AReduire, -NouvelleTaille, SEEK_END)) == ERREUR) 
    {
      Date(1) ;
      perror("\nErreur de placement dans le fichier (fseek)") ;
      exit (ERREUR) ;
    }

  Buffer = calloc(1,NouvelleTaille) ;
  
  /* Sauvegarde la zone dans un buffer */
  if ((read(fileno(AReduire), Buffer,  NouvelleTaille)) != NouvelleTaille ) 
    {
      Date(1) ;
      perror("\nErreur de lecture dans le fichier.") ;
      exit (ERREUR) ;
    }

  fclose(AReduire) ;
  
  /* Effacement et creation du fichier  rduire en ecriture */
  if ((AReduire = fopen(Fichier, "w")) == NULL)  
    {
      Date(1) ;
      fprintf(stderr,"\nImpossible d'utiliser le fichier: %s", Fichier) ;
      exit (ERREUR) ;
    }
  
  /* Ecriture dans le nouveau fichier de la zone sauvegarde */
  if ((write(fileno(AReduire), Buffer, NouvelleTaille)) != NouvelleTaille ) 
    {
      Date(1) ;
      perror("\nErreur d'ecriture dans le nouveau fichier.") ;
      exit (ERREUR) ;
    }
  
  fclose(AReduire) ;
    
}

/*****************************************************************************/

void Ajouter(type_Liste_Fichiers *FichierAAjouter)
{
  /* Ajout d'un fichier dans la liste */    
  
  type_Liste_Fichiers *Parcours ;
	
  /* Si la liste est vide, nouvelle */
  if (Fichier == NULL)
      {	
	Fichier = calloc(1,sizeof(type_Liste_Fichiers)) ;
        Fichier->TailleMax = FichierAAjouter->TailleMax ;
	Fichier->TailleMin = FichierAAjouter->TailleMin ;
	strncpy(Fichier->Nom, FichierAAjouter->Nom, strlen(FichierAAjouter->Nom)) ;
      }
      else
      {
	  Parcours = Fichier ;
	  
	  /* Parcours de la liste jusqu'au dernier fichier enregistre */
          while((Parcours->Suivant) != NULL)
	    {
	      Parcours = Parcours->Suivant ;
	    }
	  
	  /* Ajout du fichier a l'emplacement trouve */
	  
	  Parcours->Suivant = calloc(1,sizeof(type_Liste_Fichiers)) ;
	  *(Parcours)->Suivant = *FichierAAjouter ;
      }
}

/*************************************************************************/
