/***********************************************************************/
/* Nom: logController.h                                                */
/* Version: 0.4                                                        */
/* Auteur: Trankill - tranquille_che@yahoo.com                         */
/* Utilite: Controle de la taille des fichiers de log                  */
/***********************************************************************/

#include        <stdio.h>
#include        <stdlib.h>
#include        <sys/types.h>
#include        <sys/stat.h>
#include        <fcntl.h>
#include        <unistd.h>
#include        <time.h>
#include        <string.h>

/* Affichage des messages */
#define PRINT "OK"

/* Utilisation d'un fichier de log */
#define LOG "OK"


#define VRAI    1
#define FAUX    0
#define OK      0
#define ERREUR  -1

#define VERSION "0.4"

#define FICHIER_CONFIG "/etc/logController.conf"
#define FICHIER_LOG    "/var/log/logController.log"

#define PATH_GZIP "/bin/gzip"
#define PATH_BZIP2 "/usr/bin/bzip2"

#define MOT_CLE_FICHIER "NOM"
#define MOT_CLE_TAILLE_MAX "MAX"
#define MOT_CLE_RETOUR "RET"

#define MOT_CLE_ARCHIVAGE "ARC"
#define MOT_CLE_UTIL_ARCHIVAGE "ARC_UTIL"
#define MOT_CLE_PATH_ARCHIVAGE "PATH_ARC"


typedef struct FichierAChecker
{
  char Nom[60] ; 
  int TailleMax ;
  int TailleMin ;
  struct FichierAChecker *Suivant ;

} type_Liste_Fichiers ;


void LireFichierConfig(char **) ;
struct tm * Date(int ) ;
int RechercheMotCle(char *, char *, char ** ) ;
int VerifTaille(char *, int) ;
void ReducTaille(char *, int, char **) ;
void Ajouter(type_Liste_Fichiers *) ;

/***************************************************************************/
